<?php
//
// Example of usage for Services_AmazonECS4
//

require_once 'PEAR.php';
require_once 'Services/AmazonECS4.php';

echo <<<EOT
<html>
<head>
    <meta http-equiv="Content-type" content="text/html; charset=UTF-8" />
    <title>Services_AmazonECS4 example</title>
</head>
<body>
<h1>Amazon ECS4 example - ItemSearch Operation</h1>
<p>
<a href="http://www.amazon.com/gp/aws/sdk/" target="_blank">Amazon.com Help: Documentation</a><br />
<a href="http://www.amazon.com/gp/aws/sdk/main.html/?s=AWSEcommerceService&v=2005-07-26&p=ApiReference/ItemSearchOperation" target="_blank">Amazon ECS4.0 API Reference - ItemSearch Operation</a>
</p>
EOT;

$subid = $_GET['subid'];

$amazon = new Services_AmazonECS4($subid, $_GET['associd']);

// Locale
if (isset($_GET['locale'])) {
    $amazon->setLocale($_GET['locale']);
}

// ItemSearch Operation
if (!empty($subid) && $subid != 'your ID here') {
    $options = array();
    foreach ($_GET as $k => $v) {
        if ($k == 'subid' || $k == 'associd' || $k == 'locale') {
            continue;
        } else if ($k == 'SearchIndex') {
            $search_index = $v;
        } else if ($k == 'ResponseGroup') {
            foreach ($_GET['ResponseGroup'] as $v) {
                if (isset($ResponseGroup)) {
                    $ResponseGroup .= ',' . $v;
                } else {
                    $ResponseGroup = $v;
                }
            }
            $options['ResponseGroup'] = $ResponseGroup;
        } else {
            if (!empty($v)) {
                $options[$k] = $v;
            }
        }
    }

    $result = $amazon->ItemSearch($search_index, $options);

} else {
    $subid = 'your ID here';
}


// The list of all available search indexes can be found on the
// "Amazon ECS API Reference - Search Index Values"
// (http://www.amazon.com/gp/aws/sdk/main.html/?s=AWSEcommerceService&v=2005-07-26&p=ApiReference/SearchIndexValues).
$search_indexes = array('Apparel', 'Baby', 'Beauty', 'Books', 'Classical', 'DigitalMusic',
                        'DVD', 'Electronics', 'ForeignBooks', 'GourmetFood', 'HealthPersonalCare',
                        'HomeGarden', 'Jewelry', 'Kitchen', 'Magazines', 'Merchants',
                        'Miscellaneous', 'Music', 'MusicalInstruments', 'MusicTracks',
                        'OfficeProducts', 'OutdoorLiving', 'PCHardware', 'PetSupplies',
                        'Photo', 'Restaurants', 'Software', 'SoftwareVideoGames',
                        'SportingGoods', 'Tools', 'Toys', 'VHS', 'Video', 'VideoGames',
                        'Wireless', 'WirelessAccessories', 'Blended');

echo <<< EOT
<form action="{$_SERVER['PHP_SELF']}" method="get">
<table border="0">
<tr>
    <td>
    Locale: 
    <select name="locale">
EOT;

$locales = array('US', 'UK', 'DE', 'JP', 'FR', 'CA');
foreach($locales as $v) {
    echo '<option value="' . $v . ($v == $_GET['locale'] ? '" selected="selected"' : '') . '">' . $v . '</option>';
}

echo <<< EOT
    </select>
    <td>
</tr>
<tr>
    <td>Subscription ID <input type="text" name="subid" value="{$subid}" size="30" /></td>
</tr>
<tr>
    <td>Associate ID <input type="text" name="associd" value="{$_GET['associd']}" /></td>
</tr>
<tr>
    <td>
    Search Index <select name="SearchIndex">
EOT;

foreach($search_indexes as $v) {
    echo '<option value="' . $v . ($v == $_GET['SearchIndex'] ? '" selected="selected"' : '') . '">' . $v . '</option>';
}

echo <<< EOT
    </select>
    </td>
</tr>
<tr>
    <td>Keywords <input type="text" name="Keywords" value="{$_GET['Keywords']}" /></td>
</tr>
<tr>
    <td>
    <table border="0">
    <tr>
        <td>Title<br/><input type="text" name="Title" value="{$_GET['Title']}" /></td>
        <td>Artist<br/><input type="text" name="Artist" value="{$_GET['Artist']}" /></td>
        <td>Author<br/><input type="text" name="Author" value="{$_GET['Author']}" /></td>
        <td>Actor<br/><input type="text" name="Actor" value="{$_GET['Actor']}" /></td>
    </tr>
    <tr>
        <td>Director<br/><input type="text" name="Director" value="{$_GET['Director']}" /></td>
        <td>Manufacturer<br/><input type="text" name="Manufacturer" value="{$_GET['Manufacturer']}" /></td>
        <td>MusicLabel<br/><input type="text" name="MusicLabel" value="{$_GET['MusicLabel']}" /></td>
        <td>Composer<br/><input type="text" name="Composer" value="{$_GET['Composer']}" /></td>
    </tr>
    <tr>
        <td>Publisher<br/><input type="text" name="Publisher" value="{$_GET['Publisher']}" /></td>
        <td>Brand<br/><input type="text" name="Brand" value="{$_GET['Brand']}" /></td>
        <td>Conductor<br/><input type="text" name="Conductor" value="{$_GET['Conductor']}" /></td>
        <td>Orchestra<br/><input type="text" name="Orchestra" value="{$_GET['Orchestra']}" /></td>
    </tr>
    </table>
    </td>
</tr>
<tr>
    <td>Power <input type="text" name="Power" value="{$_GET['Power']}" size="80" /></td>
</tr>
<tr>
    <td>BrowseNode <input type="text" name="BrowseNode" value="{$_GET['BrowseNode']}" /></td>
</tr>
<tr>
    <td>AudienceRating <input type="text" name="AudienceRating" value="{$_GET['AudienceRating']}" /></td>
</tr>
<tr>
    <td>
    TextStream <br/>
    <textarea name="TextStream" cols="64" rows="4">{$_GET['TextStream']}</textarea>
    </td>
</tr>
<tr>
    <td>ItemPage <input type="text" name="ItemPage" value="{$_GET['ItemPage']}" /></td>
</tr>
<tr>
    <td>Sort <input type="text" name="Sort" value="{$_GET['Sort']}" /></td>
</tr>
<tr>
    <td>MinimumPrice <input type="text" name="MinimumPrice" value="{$_GET['MinimumPrice']}" /></td>
</tr>
<tr>
    <td>MaximumPrice <input type="text" name="MaximumPrice" value="{$_GET['MaximumPrice']}" /></td>
</tr>
<tr>
    <td>
    Condition
    <select name="Condition">
EOT;

$conditions = array('', 'New', 'All', 'Used', 'Refurbished', 'Collectible');

foreach ($conditions as $v) {
    echo '<option value="' . $v . ($v == $_GET['Condition'] ? '" selected="selected"' : '') . '">' . $v . '</option>';
}

echo <<< EOT
    </select>
    </td>
</tr>
<tr>
    <td>
    ResponseGroup<br/>
EOT;

$response_groups = array('Request', 'ItemIds', 'Small', 'Medium', 'Large', 'OfferFull', 'Offers',
                         'OfferSummary', 'Variations', 'VariationMinimum', 'VariationSummary',
                         'ItemAttributes', 'Tracks', 'Accessories', 'EditorialReview',
                         'SalesRank', 'BrowseNodes', 'Images', 'Similarities', 'ListmaniaLists',
                         'SearchBins', 'Subjects');

foreach ($response_groups as $v) {
    echo '<input type="checkbox" name="ResponseGroup[]" value="' . $v . '" ' . (@in_array($v, $_GET['ResponseGroup']) ? 'checked="checked"' : '') . '/>' . $v . ' ';
}

echo <<< EOT
    </td>
</tr>
<tr>
    <td><input type="submit" value="Search" /></td>
</tr>
</table>
</form>

EOT;

// examples
echo <<< EOT
<table border="0">
<tr>
    <td>Examples:</td>
    <td><a href="{$_SERVER['PHP_SELF']}?subid={$_GET['subid']}&SearchIndex=Books&Keywords=php&ResponseGroup%5B%5D=Request&ResponseGroup%5B%5D=Small">Keywords</a></td>
    <td><a href="{$_SERVER['PHP_SELF']}?subid={$_GET['subid']}&SearchIndex=Books&Keywords=php&ItemPage=2&ResponseGroup%5B%5D=Request&ResponseGroup%5B%5D=Medium">ItemPage</a></td>
    <td><a href="{$_SERVER['PHP_SELF']}?subid={$_GET['subid']}&SearchIndex=Blended&Keywords=teletubbies&ResponseGroup%5B%5D=Request&ResponseGroup%5B%5D=Small">Blended</a></td>
    <td><a href="{$_SERVER['PHP_SELF']}?subid={$_GET['subid']}&SearchIndex=Books&Power=%28subject%3A+sushi+or+pizza%29+and+pubdate%3A+after+2000&ResponseGroup%5B%5D=Request&ResponseGroup%5B%5D=ItemAttributes">Power</a></td>
    <td><a href="{$_SERVER['PHP_SELF']}?subid={$_GET['subid']}&SearchIndex=Electronics&BrowseNode=595046&ResponseGroup%5B%5D=Request&ResponseGroup%5B%5D=Small&ResponseGroup%5B%5D=ItemAttributes">BrowseNode</a></td>
    <td><a href="{$_SERVER['PHP_SELF']}?subid={$_GET['subid']}&SearchIndex=Electronics&BrowseNode=301187&Sort=salesrank&ResponseGroup%5B%5D=Request&ResponseGroup%5B%5D=ItemAttributes">Sort</a></td>
    <td><a href="{$_SERVER['PHP_SELF']}?subid={$_GET['subid']}&SearchIndex=Books&Keywords=programming&MinimumPrice=5000&MaximumPrice=10000&ResponseGroup%5B%5D=Request&ResponseGroup%5B%5D=Small&ResponseGroup%5B%5D=OfferSummary">Price</a></td>
    <td><a href="{$_SERVER['PHP_SELF']}?subid={$_GET['subid']}&SearchIndex=DVD&AudienceRating=PG-13&ResponseGroup%5B%5D=Request&ResponseGroup%5B%5D=ItemAttributes">AudienceRating</a></td>
</tr>
</table>

<hr/>
EOT;

// REST request
$lasturl = $amazon->getLastUrl();
echo '<p>REST request:<br/>';
echo '<a href="' . $lasturl . '" target="_blank">' . ereg_replace('&', '<br/>&', $lasturl) .  '</a></p>';

if (PEAR::isError($result)) {
    // Error
    echo '<p>Error:<br/>';
    echo $result->message;
    echo '</p>';
} else {

    // Processing Time
    echo '<p>Processing Time: ' . $amazon->getProcessingTime() . 'sec</p>';

    // Result
    echo '<p>Result:';
    var_dump($result);
    echo '</p>';
}

echo <<< EOT
</body>
</html>
EOT;

?>
